// Generated by CoffeeScript 1.6.3
(function() {
  var argsToQueryString, reqwest,
    __slice = [].slice;

  reqwest = require('reqwest');

  argsToQueryString = function(args) {
    return Object.keys(args).map(function(key) {
      return encodeURIComponent(key) + '=' + encodeURIComponent(args[key]);
    }).join('&');
  };

  exports.construct = function(_arg) {
    var endpoint, timeout;
    endpoint = _arg.endpoint, timeout = _arg.timeout;
    if (timeout == null) {
      timeout = 5000;
    }
    return function(method, params, callback) {
      var onceCallback;
      onceCallback = (function() {
        var called;
        called = false;
        return function() {
          var args;
          args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
          if (called) {
            return;
          }
          called = true;
          return callback.apply(null, args);
        };
      })();
      setTimeout(function() {
        return onceCallback(new Error('Timeout'));
      }, timeout);
      return reqwest({
        type: 'jsonp',
        method: 'get',
        url: endpoint + ("/" + method + "?") + argsToQueryString(params),
        success: function(data) {
          var _ref;
          if (data.error) {
            return onceCallback(new Error((_ref = data.error) != null ? _ref.data : void 0));
          }
          return onceCallback(null, data.result);
        },
        error: function() {
          return onceCallback(new Error('error'));
        }
      });
    };
  };

}).call(this);
